@extends('app')

@section('station_active', 'class="active"')

@section('content')
<div id="custom_alert"></div>
<h3><i class="fa fa-wrench"></i>&nbsp;&nbsp;Configure Ambient Noise Sensor - {{ $station->name }} ({{ $station->extension}}) &nbsp;&nbsp;<a href="/help/topics/#t=<?php echo $topicurl; ?>" target="_blank" class="btn btn-primary" role="button"><i class='fa fa-lg fa-question-circle'></i></a></h3>
<hr>
<h3>ANS Listeners&nbsp;&nbsp;<button type="button" class="btn btn-xs btn-success" onClick="addRow();"><i class='fa fa-plus'></i></button></h3>
<form method="POST" action="/station/save_ans_stations" enctype="multipart/form-data">
	<input type="hidden" name="_token" value="{{ csrf_token() }}">
	<input type="hidden" name="dataArray" id="dataArray" value="">
	<input name="station_extension" id="station_extension" type="hidden" value="<?php echo $station->extension;?>">
	<input name="station_id" id="station_id" type="hidden" value="<?php echo $station->id;?>">
<div class="row">
   <div class="col-md-8">
	<table id="stations_table" class="table table-striped">
    	<thead>
        	<tr>
				<th class="text-nowrap" data-align="center" data-width="50">Remove</th>	
            	<th class="text-nowrap" data-align="center"><a data-toggle="tooltip" title='<?php echo $ans_listeners_help->listener_ext;?>'><strong>Station</strong></a></th>
				<th class="text-nowrap" data-align="center"><a data-toggle="tooltip" title='<?php echo $ans_listeners_help->ans_max_boost;?>'><strong>Max Boost (dB)</strong></a></th>
				<th class="text-nowrap" data-align="center"><a data-toggle="tooltip" title='<?php echo $ans_listeners_help->ans_threshold;?>'><strong>Threshold (dBFS)</strong></a></th>
				<th class="text-nowrap" data-align="center"><a data-toggle="tooltip" title='<?php echo $ans_listeners_help->ans_volume_adjust;?>'><strong>Volume Adjust (dB)</strong></a></th>
				<th class="text-nowrap" data-align="center"><a data-toggle="tooltip" title='<?php echo $ans_listeners_help->ans_sample_length;?>'><strong>Sample Length (s)</strong></a></th>
			</tr>
		</thead>
		<tbody>
	@foreach($ans_listeners as $key => $listener)
			<tr id="row<?php echo $key;?>">
				<td class="text-nowrap" data-align="center"><button type="button" class="btn btn-xs btn-danger" onClick="deleteRow(<?php echo $key;?>);"><i class='fa fa-times'></i></button></td>
				<td class="text-nowrap" data-align="center"><a href="#" id="listener_ext<?php echo $key;?>">{{ $listener->listener_ext }}</a></td>
				<td class="text-nowrap" data-align="center"><a href="#" id="ans_max_boost<?php echo $key;?>">{{ $listener->ans_max_boost }}</a></td>
				<td class="text-nowrap" data-align="center"><a href="#" id="ans_threshold<?php echo $key;?>">{{ $listener->ans_threshold }}</a></td>
				<td class="text-nowrap" data-align="center"><a href="#" id="ans_volume_adjust<?php echo $key;?>">{{ $listener->ans_volume_adjust }}</a></td>
				<td class="text-nowrap" data-align="center"><a href="#" id="ans_sample_length<?php echo $key;?>">{{ $listener->ans_sample_length }}</a></td>
			</tr>
	@endforeach
         </tbody>
    </table>
  </div>
</div>
</form>
<br><br>
<div class="form-group">
		<a href="/station/<?php echo $station->id;?>/edit" class="btn btn-default" role="button"><i class='fa fa-times'></i> Cancel</a>&nbsp;&nbsp;<button class="btn btn-success" type="submit" onclick="this.disabled=true;forms[0].submit();"><i class="fa fa-floppy-o"></i> Save</button>
	</div>
@stop

@section('title')
	Configure Ambient Noise Sensor 

@stop

@section('footer')
 <script>
var dataArray = [];
$(document).ready(function() { // start ready function
	
	$.fn.editable.defaults.mode = 'inline';
	
	buildDataArray();
	
	addXEditableElements();
	
}); // end ready function
	 
// bootstrap-table settings
$('#stations_table').bootstrapTable({
    search: false,
	striped: false,
	classes: 'table',
	showToggle: false,
	trimOnSearch: false,
}).on('sort.bs.table', function (e, name, order) {
	
}).on('all.bs.table', function (e, name, order) {
	
}).on('click-row.bs.table', function (e, row, $element) { 
    		
});
// delete row
function deleteRow(id){
   $("#row" + id).remove(); // remove the table row
	for(var row=0; row<dataArray.length; row++){
		if(id==dataArray[row][0]){
			dataArray.splice(row,1); // remove the data row
		}
	}
	document.getElementById('dataArray').value = JSON.stringify(dataArray);
}
// add row
function addRow(){
	var row_id = dataArray.length;
	var row_number = dataArray.length+1;
	var table = document.getElementById("stations_table");
	if(dataArray.length==0 && table.rows.length==2){ // removes 'No matching records found' row
	   table.deleteRow(1);
	 }
    var row = table.insertRow(row_number);
	row.id = 'row'+row_id;
	row.innerHTML = '<tr id="row'+row_id+'"><td class="text-nowrap" data-align="center"><p align="center"><button type="button" class="btn btn-xs btn-danger" onClick="deleteRow('+row_id+');"><i class=\'fa fa-times\'></i></button></p></td><td class="text-nowrap" data-align="center"><p align="center"><a href="#" id="listener_ext'+row_id+'"></a></p></td><td class="text-nowrap" data-align="center"><p align="center"><a href="#" id="ans_max_boost'+row_id+'">0</a></p></td><td class="text-nowrap" data-align="center"><p align="center"><a href="#" id="ans_threshold'+row_id+'">-24</a></p></td><td class="text-nowrap" data-align="center"><p align="center"><a href="#" id="ans_volume_adjust'+row_id+'">12</a></p></td><td class="text-nowrap" data-align="center"><p align="center"><a href="#" id="ans_sample_length'+row_id+'">3</a></p></td></tr>';
		
	// add x-editable elements
	$('#listener_ext'+row_id).editable({
			value: '',  
			type: 'select',
			pk: 1,
			url: '',
			title: 'Select extention',
			success: function(response, newValue){
				dataArray[row_id][2] = newValue;
				document.getElementById('dataArray').value = JSON.stringify(dataArray);
			},
			source: [
				<?php foreach($available_extensions as $extension){ ?>
				  {value: '<?php echo $extension;?>', text: '<?php echo $extension;?>'},
				<?php } ?>
			   ],
		});
	
		$('#ans_max_boost'+row_id).editable({
			type: 'text',
			pk: 1,
			url: '',
			title: 'Enter max boost',
			success: function(response, newValue){
				dataArray[row_id][3] = parseInt(newValue);
				document.getElementById('dataArray').value = JSON.stringify(dataArray);
			},
			validate: function(value){
			 if($.trim(value) == ''){
				 return 'Number is required';
			 } else if ($.isNumeric(value) == ''){
				 return 'Only numbers allowed';
			 } else if (value<-42 || value >0){
					return 'Max Boost range is -42 to 0';
			 }
			},
		});
	
		$('#ans_threshold'+row_id).editable({
			type: 'text',
			pk: 1,
			url: '',
			title: 'Enter ANS threshold',
			success: function(response, newValue){
				dataArray[row_id][4] = parseInt(newValue);
				document.getElementById('dataArray').value = JSON.stringify(dataArray);
			},
			validate: function(value){
			 if($.trim(value) == ''){
				 return 'Number is required';
			 } else if ($.isNumeric(value) == ''){
				 return 'Only numbers allowed';
			 } else if (value<-42 || value >0){
					return 'Threshold range is -42 to 0';
			 }
			},
		});
	
		$('#ans_volume_adjust'+row_id).editable({
			type: 'text',
			pk: 1,
			url: '',
			title: 'Enter ANS volue adjust',
			success: function(response, newValue){
				dataArray[row_id][5] = parseInt(newValue);
				document.getElementById('dataArray').value = JSON.stringify(dataArray);
			},
			validate: function(value){
			 if($.trim(value) == ''){
				 return 'Number is required';
			 } else if ($.isNumeric(value) == ''){
				 return 'Only numbers allowed';
			 } else if (value<0 || value >42){
					return 'Volume Adjust range is 0 to 42';
			 }
			},
		});
	
		$('#ans_sample_length'+row_id).editable({
			type: 'text',
			pk: 1,
			url: '',
			title: 'Enter ANS sample length',
			success: function(response, newValue){
				dataArray[row_id][6] = parseInt(newValue);
				document.getElementById('dataArray').value = JSON.stringify(dataArray);
			},
			validate: function(value){
			 if($.trim(value) == ''){
				 return 'Number is required';
			 } else if ($.isNumeric(value) == ''){
				 return 'Only numbers allowed';
			 } else if (value<1 || value >20){
					return 'Smaple length range is 1 to 20';
			 }
			},
		});
	
	var station_extension = document.getElementById('station_extension').value;
	
	dataArray.push([row_id, station_extension, '', 0, -24 , 12, 3]);
	document.getElementById('dataArray').value = JSON.stringify(dataArray);
}
// build data array
function buildDataArray(){
	<?php foreach($ans_listeners as $key => $listener){ ?>
		dataArray.push([<?php echo $key;?>, '<?php echo  $listener->ans_ext;?>', '<?php echo  $listener->listener_ext;?>', <?php echo  $listener->ans_max_boost;?>, <?php echo  $listener->ans_threshold;?>, <?php echo  $listener->ans_volume_adjust;?>, <?php echo  $listener->ans_sample_length;?>]);
	<?php } ?>
	document.getElementById('dataArray').value = JSON.stringify(dataArray);
}
function addXEditableElements(){
	<?php foreach($ans_listeners as $key => $listener){ ?>
	
		$('#listener_ext<?php echo $key;?>').editable({
			value: '<?php echo $listener->listener_ext; ?>',  
			type: 'select',
			pk: 1,
			url: '',
			title: 'Select extention',
			success: function(response, newValue){
				dataArray[<?php echo $key;?>][2] = newValue;
				document.getElementById('dataArray').value = JSON.stringify(dataArray);
			},
			source: [
				<?php foreach($available_extensions as $extension){ ?>
				  {value: '<?php echo $extension;?>', text: '<?php echo $extension;?>'},
				<?php } ?>
			   ],
		});
	
		$('#ans_max_boost<?php echo $key;?>').editable({
			type: 'text',
			pk: 1,
			url: '',
			title: 'Enter max boost',
			success: function(response, newValue){
				dataArray[<?php echo $key;?>][3] = parseInt(newValue);
				document.getElementById('dataArray').value = JSON.stringify(dataArray);
			},
			validate: function(value){
			 if($.trim(value) == ''){
				 return 'Number is required';
			 } else if ($.isNumeric(value) == ''){
				 return 'Only numbers allowed';
			 } else if (value<-42 || value >0){
					return 'Max Boost range is -42 to 0';
			 }
			},
		});
	
		$('#ans_threshold<?php echo $key;?>').editable({
			type: 'text',
			pk: 1,
			url: '',
			title: 'Enter ANS threshold',
			success: function(response, newValue){
				dataArray[<?php echo $key;?>][4] = parseInt(newValue);
				document.getElementById('dataArray').value = JSON.stringify(dataArray);
			},
			validate: function(value){
			 if($.trim(value) == ''){
				 return 'Number is required';
			 } else if ($.isNumeric(value) == ''){
				 return 'Only numbers allowed';
			 } else if (value<-42 || value >0){
					return 'Threshold range is -42 to 0';
			 }
			},
		});
	
		$('#ans_volume_adjust<?php echo $key;?>').editable({
			type: 'text',
			pk: 1,
			url: '',
			title: 'Enter ANS volue adjust',
			success: function(response, newValue){
				dataArray[<?php echo $key;?>][5] = parseInt(newValue);
				document.getElementById('dataArray').value = JSON.stringify(dataArray);
			},
			validate: function(value){
			 if($.trim(value) == ''){
				 return 'Number is required';
			 } else if ($.isNumeric(value) == ''){
				 return 'Only numbers allowed';
			 } else if (value<0 || value >42){
					return 'Volume Adjust range is 0 to 42';
			 }
			},
		});
	
		$('#ans_sample_length<?php echo $key;?>').editable({
			type: 'text',
			pk: 1,
			url: '',
			title: 'Enter ANS sample length',
			success: function(response, newValue){
				dataArray[<?php echo $key;?>][6] = parseInt(newValue);
				document.getElementById('dataArray').value = JSON.stringify(dataArray);
			},
			validate: function(value){
			 if($.trim(value) == ''){
				 return 'Number is required';
			 } else if ($.isNumeric(value) == ''){
				 return 'Only numbers allowed';
			 } else if (value<1 || value >20){
					return 'Sample length range is 1 to 20';
			 }
			},
		});
	
	<?php } ?>
}
// calculate the table height
 var document_height = window.innerHeight;
 var table_height = parseInt(document_height*0.8);
//  Flash message 
$('div.alert').delay(5000).slideUp(300);
//  tool tip
$(function () {
  $('[data-toggle="tooltip"]').tooltip()
});

</script>
@endsection

